#include <math.h>

#include "e_var.h"
#include "ctes.h"
void dyn()
{
int i;

// Dynamics calculations of the rocket
      
// g calculation
for (i=1;i<=st_nb+1;i++)
    {
      g[i]=6.67*pow(10,-11)*5.98*pow(10,24)/pow((6.378*pow(10,6)+alt[i]),2);
    };
    
// Calculation of the Gravity angle
teta[bu_st] = atan2(y[bu_st],x[bu_st]);

// Calculation of the accelerations
ax[bu_st]=(-m*g[bu_st]*cos(teta[bu_st])+th[bu_st]*cos(pitch*pi/180)-.5*rho[bu_st]*sa[bu_st]*cz[st_nb]*speed[bu_st]*speed[bu_st]*sin(tangle[bu_st])-.5*rho[bu_st]*sr[bu_st]*cx[st_nb]*speed[bu_st]*speed[bu_st]*cos(tangle[bu_st]))/m;
az[bu_st]=(-m*g[bu_st]*sin(teta[bu_st])+th[bu_st]*sin(pitch*pi/180)+.5*rho[bu_st]*sa[bu_st]*cz[st_nb]*speed[bu_st]*speed[bu_st]*cos(tangle[bu_st])-.5*rho[bu_st]*sr[bu_st]*cx[st_nb]*speed[bu_st]*speed[bu_st]*sin(tangle[bu_st]))/m;

// Calculation of the speeds
speedx[bu_st]=speedx[bu_st]+ax[bu_st]*dt;
speedz[bu_st]=speedz[bu_st]+az[bu_st]*dt;
speed[bu_st] = sqrt(speedx[bu_st]*speedx[bu_st]+speedz[bu_st]*speedz[bu_st]);

// Calculation of the trajectory tangent angle
tangle[bu_st] = atan2(speedz[bu_st],speedx[bu_st]);

// Calculation of the coordinates and altitude
x[bu_st]=x[bu_st]+speedx[bu_st]*dt;
y[bu_st]=y[bu_st]+speedz[bu_st]*dt;
alt[bu_st]= pow((x[bu_st]*x[bu_st]+y[bu_st]*y[bu_st]),.5)-6378000.;

// alt[bu_st]=alt[bu_st]+speedz[bu_st]*dt;
// l[0]=l[0]+speed[0]*dt;

// pitch = atan(1500./pow(l,.70))*180./pi;
pitch = 90.*pow(rho[bu_st],.20);

for (i=bu_st+1;i<=st_nb+1;i++)
    {
    ax[i]=ax[bu_st];
    az[i]=az[bu_st];
    speedx[i]=speedx[bu_st];
    speedz[i]=speedz[bu_st];
    speed[i]=speed[bu_st];
    x[i]=x[bu_st];
    y[i]=y[bu_st];
    alt[i]=alt[bu_st];
    tangle[i]=tangle[bu_st];
    teta[i] = teta[bu_st];
    g[i] = g[bu_st];
    };
    
if (bu_st!=1)
   for (i=1;i<=bu_st-1;i++)
   {
       // Dynamics calculations of the stages
       
teta[i] = atan2(y[i],x[i]);

// Calculation of the accelerations
ax[i]=(-m*g[i]*cos(teta[i])-.5*rho[i]*sa[i]*cz[i]*speed[i]*speed[i]*sin(tangle[i])-.5*rho[i]*sr[i]*cx[i]*speed[i]*speed[i]*cos(tangle[i]))/m;
az[i]=(-m*g[i]*sin(teta[i])+.5*rho[i]*sa[i]*cz[i]*speed[i]*speed[i]*cos(tangle[i])-.5*rho[i]*sr[i]*cx[i]*speed[i]*speed[i]*sin(tangle[i]))/m;

// Calculation of the speeds
speedx[i]=speedx[i]+ax[i]*dt;
speedz[i]=speedz[i]+az[i]*dt;
speed[i] = sqrt(speedx[i]*speedx[i]+speedz[i]*speedz[i]);

// Calculation of the coordinates and altitude
x[i]=x[i]+speedx[i]*dt;
y[i]=y[i]+speedz[i]*dt;
alt[i]= pow((x[i]*x[i]+y[i]*y[i]),.5)-6378000.;
if (alt[i]<0)
   alt[i]=0.;

// alt[i]=alt[i]+speedz[i]*dt;       

tangle[i]=atan2(speedz[i],speedx[i]);
       };
}
